# ----------------------------------------------------------------------------
# Copyright (c) 2017 Semiconductor Components Industries, LLC (d/b/a
# ON Semiconductor), All Rights Reserved
#
# This code is the property of ON Semiconductor and may not be redistributed
# in any form without prior written permission from ON Semiconductor.
# The terms of use and warranty for this code are covered by contractual
# agreements between ON Semiconductor and the licensee.
#
# This is Reusable Code.
#
# -----------------------------------------------------------------------------
#

from baseFileWrapper import baseFileWrapper

class baseFileStreamWrapper(baseFileWrapper):
    ''' Base class for a wrapper on a file which is accessed as a stream '''

    def __init__(self, wrappedFile):
        ''' Constructor takes a wrapped file '''
        super(baseFileStreamWrapper, self).__init__(wrappedFile)
        self.fp = 0

    def seek(self, offset, fromWhat = 0):
        ''' Define a standard seek operation '''
        if fromWhat == 0:
            self.fp = offset
        if fromWhat == 1:
            self.fp += offset
        if fromWhat == 2:
            self.fp = len(self.bytes) - offset
        if self.fp < 0:
            self.fp = 0
        if self.fp > len(self.bytes):
            self.fp = len(self.bytes)
    
    def tell(self):
        ''' report the current file pointer '''
        return self.fp

