/* ----------------------------------------------------------------------------
 * Copyright (c) 2016-2017 Semiconductor Components Industries, LLC (d/b/a
 * ON Semiconductor), All Rights Reserved
 *
 * This code is the property of ON Semiconductor and may not be redistributed
 * in any form without prior written permission from ON Semiconductor.
 * The terms of use and warranty for this code are covered by contractual
 * agreements between ON Semiconductor and the licensee.
 *
 * This is Reusable Code.
 *
 * ----------------------------------------------------------------------------
 * rsl10_lpdsp32_vector.h
 * - LPDSP32 Interrupt enumeration and helper function definitions
 * ----------------------------------------------------------------------------
 * $Revision: 1.5 $
 * $Date: 2017/06/12 16:10:32 $
 * ------------------------------------------------------------------------- */

#ifndef RSL10_LPDSP32_VECTOR_H
#define RSL10_LPDSP32_VECTOR_H

/* ----------------------------------------------------------------------------
 * If building with a C++ compiler, make all of the definitions in this header
 * have a C binding.
 * ------------------------------------------------------------------------- */
#if defined(__cplusplus)
extern "C"
  {
#endif

/* ----------------------------------------------------------------------------
 * Interrupt Vector Table Numbers
 *  - Does not contain reset vector interrupt enumeration.
 *  - Contains enumerations for 15 interrupt channels avaiable on the LPDSP32
 * -------------------------------------------------------------------------*/
typedef enum IRQDSP
{
    DMA0DSP_IRQDSP = 0,
    DMA1DSP_IRQDSP = 1,
    DMA2DSP_IRQDSP = 2,
    DMA3DSP_IRQDSP = 3,
    DMA4DSP_IRQDSP = 4,
    DMA5DSP_IRQDSP = 5,
    DMA6DSP_IRQDSP = 6,
    DMA7DSP_IRQDSP = 7,
    ARM0DSP_IRQDSP = 8,
    ARM1DSP_IRQDSP = 9,
    ARM2DSP_IRQDSP = 10,
    ARM3DSP_IRQDSP = 11,
    ARM4DSP_IRQDSP = 12,
    ARM5DSP_IRQDSP = 13,
    ARM6DSP_IRQDSP = 14
} IRQDSP_Type;

unsigned int enable_interrupt_mask_number(unsigned int interrupt_index);

unsigned int disable_interrupt_mask_number(unsigned int interrupt_index);

#if defined(__cplusplus)
  }
#endif

#endif /* RSL10_LPDSP32_VECTOR_H */
